#include <iostream>
#include <sstream>
#include <vector>
#include <curl/curl.h>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& inp, bool prompt){
    size_t number_count;
    if (prompt){
        cerr << "enter number_count";
    }
    inp >> number_count;

    Input in;
    in.numbers.resize(number_count);
    if (prompt){
        std::cerr << "enter numbers";
    }
    for (size_t i = 0; i < number_count; i++){
        inp >> in.numbers[i];
    }
    if (prompt){
        std::cerr << "enter bin_count";
    }
    inp >> in.bin_count;
    return in;
}

int main(int argc, char* argv[]){
    curl_global_init(CURL_GLOBAL_ALL);
    if (argc > 1 ){
        CURL* curl = curl_easy_init();
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            if (res != CURLE_OK){
                cerr << curl_easy_strerror(res);
                exit(1);
            }
            curl_easy_cleanup(curl);
        }
        return 0;
    }
    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    auto borders = make_borders(in.numbers, in.bin_count);
    show_histogram_svg(bins, borders, in.bin_count);
}
